#include <sys/types.h>	/* notendige ... */
#include <dirent.h>	/* ... Includes */
#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv) {
	DIR *dir;
	struct dirent *entry;

	if (argc != 2) {
		fprintf(stderr, "Usage: %s <dir>\n", argv[0]);
		exit(1);
	}

	/* Verbindung zu Verzeichnis oeffnen ... */
	if ((dir = opendir(argv[1])) == NULL)
		perror("opendir()"), exit(2);

	/*
	 * Eintraege lesen
	 * NULL => Ende bzw. Fehler
	 */
	while ((entry = readdir(dir)) != NULL) {
		/*
		 * wesentliche Elemente eines Verzeichniseintrags:
		 *
		 *	d_name		der Dateiname
		 *	d_ino		die Inode-Nummer
		 */
		printf("%-20s (%d)\n", entry->d_name, (int) entry->d_ino);
	}

	/* Verbindung zu Verzeichnis wieder sauber beenden */
	closedir(dir);

	exit(0);	/* ... und tschuess! */
}
