#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

int main() {
	int fd;

	/*
	 * Datei stdout.txt zum Schreiben oeffnen (anlegen bzw. auf Laenge
	 * 0 verkuerzen).
	 *
	 * => Ergebnis ist ein bisher freier FD, der nun diese Verbindung repraes.
	 */
	if ((fd = open("stdout.txt", O_WRONLY | O_CREAT | O_TRUNC, 0664)) < 0)
		perror("open"), exit(1);

	close(1);	/* FD 1 schliessen => dies ist der kleinste freie FD */
	dup(fd);	/* FD fd kopieren => Ergebnis ist kleinster freier FD, also 1 */

	    /* jetzt ist die Umlenkung der Standardausgabe nach stdout.txt aktiv! */

	close(fd);	/* dieser FD bezeichnet nun die selbe Verbindung wir 1 => schliessen da doppelt */

	/*
	 * Jetzt geht alles, was auf stdout geschrieben wird in die Datei stdout.txt
	 */

	puts("Hallo Welt!");

	return 0;
}
