#include <sys/types.h>	/* notwendige ... */
#include <sys/stat.h>	/* ... Includes */
#include <time.h>
#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv) {
	struct stat statbuf;

	if (argc != 2) {
		fprintf(stderr, "Usage: %s <file>\n", argv[0]);
		exit(1);	/* Programm mit Exit-Status 1 terminieren */
	}

	    /*
	     * Unterschied zwischen stat() und lstat():
	     * stat() liefert bei symb. Link Info ueber
	     * die Datei, auf die er zeigt!
	     * lstat() liefert bei symb. Link Info ueber
	     * die symb. Linkdatei selbst!
	     */
	if (lstat(argv[1], &statbuf) < 0)
		perror("stat()"), exit(2);

	printf("UID: %d\n", (int) statbuf.st_uid);	/* User ID der Datei */
	printf("GID: %d\n", (int) statbuf.st_gid);	/* Group ID der Datei */

		/* in Sekunden seit 1.1.1970, 0:00 Uhr */
	printf("access time: %d\n", (int) statbuf.st_atime);
		/* oder formatiert */
	printf("access time: %s", ctime(&statbuf.st_atime));

	    /*
	     * Bestimmung der Rechte am besten mit Oktalmasken!
	     */
	printf("Rechte der Gruppe: %c%c%c\n",
		statbuf.st_mode & 040 ? 'r' : '-',
		statbuf.st_mode & 020 ? 'w' : '-',
		statbuf.st_mode & 010 ? 'x' : '-');

	printf("Sticky-Bit: %s\n", statbuf.st_mode & 01000 ? "ja" : "nein");

	printf("Anzahl der Dateinamen: %d\n", (int) statbuf.st_nlink);

	printf("Inode-Nummer: %d\n", (int) statbuf.st_ino);

	printf("Verzeichnis? %s\n", (statbuf.st_mode & S_IFMT) == S_IFDIR ? "ja" : "nein");
	
	/*
	 * Makros machen das Leben leichter
	 * -- auch bei der Bestimmung des Dateityps (siehe man stat)
	 */
	printf("Verzeichnis? %s\n", S_ISDIR(statbuf.st_mode) ? "ja" : "nein");

	exit(0);
}
